#!/usr/local/bin/perl
$version='9.0';
$file='linkdiag.txt';
print "Welcome to the LinkScan $version Diagnostics.\n";
print "This utility creates the ASCII file $file.\n";
print "Please mail this file to linkscan\@elsop.com on request.\n";
open(DIAG,">linkdiag.txt") or die "Could not open $file: $!\n";
$Winnt=0;
if($^O=~m/mswin/i){$Winnt=1;}
if($Winnt){
  ($server)=gethostbyname('localhost');
  $login=getlogin();
}else{
  $server=`uname -n`;
  $login=getpwuid($>);
}
$server=~tr/\0\r\n//d;
print "Server Name: $server\n";
print "Login  Name: $login\n";
$perl=$];
$perl=~s/[\n\r]//g;
$eserver=$server;
$eserver=~s/(.)/uc sprintf("%%%02x",ord($1))/egs;
$elogin=$login;
$elogin=~s/(.)/uc sprintf("%%%02x",ord($1))/egs;
print DIAG "SYSTEM PARAMETERS per LinkDiag $version\n\n";
print DIAG "uname -a:    $server  $eserver\n";
print DIAG "Login:       $login  $elogin\n";
print DIAG "Perl:        $perl\n";
foreach $item(sort keys (%ENV)){
  print DIAG "ENV: $item = $ENV{$item}\n";
}

$Lsdir='';
if($Winnt){
  $Lsdir=`cd`;
  $Lsdir=~s/[\r\n\s]//g;
  $Lsdir=~s#\\#/#g;
  $cmd='DIR';
}else{
  $Lsdir=`pwd`;
  $Lsdir=~s/[\r\n\s]//g;
  $cmd='ls -al';
}
unless($Lsdir=~m#/$#){$Lsdir .='/';}
print "Current Working Dir: $Lsdir\n";
print DIAG "\n\nCurrent Working Dir: $Lsdir\n\n";
open(INP,"$cmd |");
while(<INP>){
  s/[\r\n]//g;
  print DIAG "DIR $_\n";
}
close(INP);

$Dotfile='.linkscan';
$Sysfile='linkscan.sys';
$Masfile='linkscan.mas';
$Cfgfile='linkscan.cfg';
$Audfile='linkscan.aud';
$Dbgfile='linkscan.dbg';
$Datadir='data/';

if(open(INP,"<$Dotfile")){
  print "\n\nFILE: $Dotfile\n\n";
  print DIAG "\n\nFILE: $Dotfile\n\n";
  while(<INP>){
    s/[\r\n\s]//g;
    s/#.*//;
    unless($_){next;}
    $Lsdir=$_;
  }
  close(INP);
  print "Followed .linkscan to: $Lsdir\n";
  print DIAG "Followed .linkscan to: $Lsdir\n";
}

print DIAG "\n\nFILE: $Lsdir$Sysfile\n\n";
open(INP,"<$Lsdir$Sysfile") or die "Could not open $Lsdir$Sysfile: $!\n";
while(<INP>){
  s/[\r\n]//g;
  if(m/^#/){next;}
  if($_){print DIAG "$_\n";}
  $var=$_;
  m/=(.*)/i;
  $val=$1;
  $var=~s/^\s+//;
  $var=~s/\s+$//;
  $val=~s/^\s+//;
  $val=~s/\s+$//;
  if($var=~m/^Cfgfile/i){$Cfgfile=$val;}
  elsif($var=~m/^Audfile/i){$Audfile=$val;}
  elsif($var=~m/^Datadir/i){$Datadir=$val;}
  elsif($var=~m/^Masfile/i){$Masfile=$val;}
  elsif($var=~m/^Linkscandir/i){$Lsdir=$val;}
}
close(INP);
$Audfile=$Datadir.$Audfile;

@Files=($Cfgfile);
foreach $file(@Files){
  print DIAG "\n\nFILE: $Lsdir$file \n\n";
  open(INP,"<$Lsdir$file");
  while(<INP>){
    s/[\r\n]//g;
    if(m/^#/){next;}
    if($_){print DIAG "$_\n";}
  }
  close(INP);
}

print DIAG "\n\nFILE: $Lsdir$Masfile\n\n";
if(open(INP,"<$Lsdir$Masfile")){
  while(<INP>){
    s/[\r\n]//g;
    if(m/^#/){next;}
    if($_){
      print DIAG "$_\n";
      m/(\S+)/;
      push(@Projects,$1);
    }
  }
  close(INP);
}

unless(@Projects){@Projects=('default');}
$line='=' x 72;
@Files=($Cfgfile,$Audfile,$Dbgfile);
foreach $proj(sort @Projects) {
  print DIAG "\n$line\nPROJECT: $proj\n\n";
  foreach $file(@Files){
    $afile=$proj.'/'.$file;
    print DIAG "\n\nFILE: $Lsdir$afile \n\n";
    open(INP,"<$Lsdir$afile");
    while(<INP>){
      s/[\r\n]//g;
      s/\cG/ \| /g;
      if(m/^#/){next;}
      if($_){print DIAG "$_\n";}
    }
    close(INP);
  }
}
close(DIAG);
print "Completed!\n";
exit;

